@echo off
:: Verifica se o script está rodando como administrador
net session >nul 2>&1
if %errorlevel% neq 0 (
    echo Solicitando permissao de administrador...
    PowerShell -Command "Start-Process '%~f0' -Verb runAs"
    exit /b
)

setlocal

REM ============================================================
REM 1. Determina o diretório da instalação (pasta do batch)
REM ============================================================
set "INSTALL_DIR=%~dp0"
set "APP_EXE=%INSTALL_DIR%Kalkan Hardware Monitor.exe"

REM ============================================================
REM 2. Adiciona o programa ao Registro para execucao na inicializacao
REM ============================================================
reg add "HKCU\Software\Microsoft\Windows\CurrentVersion\Run" /v "Kalkan Hardware Monitor" /t REG_SZ /d "\"%APP_EXE%\"" /f
if %errorlevel% equ 0 (
    echo Registro de inicio adicionado com sucesso!
) else (
    echo Erro ao adicionar o registro de inicio.
)

REM ============================================================
REM 3. Cria atalho no Menu Iniciar usando VBScript
REM ============================================================
REM Define o local do Menu Iniciar para o usuario atual
set "StartMenuDir=%APPDATA%\Microsoft\Windows\Start Menu\Programs"
set "ShortcutPath=%StartMenuDir%\Kalkan Hardware Monitor.lnk"

REM Define o caminho para o arquivo VBScript na mesma pasta do batch
set "VBSFile=%INSTALL_DIR%CriarAtalho.vbs"

REM Cria o arquivo VBScript com comandos echo individuais
echo Set WshShell = WScript.CreateObject("WScript.Shell") > "%VBSFile%"
echo Set oShellLink = WshShell.CreateShortcut("%ShortcutPath%") >> "%VBSFile%"
echo oShellLink.TargetPath = "%APP_EXE%" >> "%VBSFile%"
echo oShellLink.WorkingDirectory = "%INSTALL_DIR%" >> "%VBSFile%"
echo oShellLink.WindowStyle = 1 >> "%VBSFile%"
echo oShellLink.Save >> "%VBSFile%"

REM Verifica se o arquivo VBScript foi criado e o executa
if exist "%VBSFile%" (
    cscript //nologo "%VBSFile%"
    if %errorlevel% equ 0 (
        echo Atalho no Menu Iniciar criado com sucesso!
    ) else (
        echo Erro ao executar o script VBScript para criar o atalho.
    )
    del "%VBSFile%"
) else (
    echo Nao foi possivel criar o arquivo de script VBScript.
)

REM ============================================================
REM 4. Cria tarefa agendada para execucao do programa com privilegios elevados
REM ============================================================
REM Cria uma tarefa que executa o programa no logon com o nivel de execucao mais alto.
schtasks /create /tn "KalkanHardwareMonitorElevado" /tr "\"%APP_EXE%\"" /sc onlogon /rl highest /f
if %errorlevel% equ 0 (
    echo Tarefa agendada criada com sucesso!
) else (
    echo Erro ao criar a tarefa agendada.
)

echo.
echo Operacao completa. Pressione qualquer tecla para sair...
pause >nul
endlocal
